from fabric.api import *
from fabric.colors import *

env.roledefs = {
    'server1': ['billy@ubuntuserver.com',]
}

# Recommend use auto login
# env.password = 'password'

env.passwords = {
    'server1': "password",
}
env.warn_only = True

@roles('server1')
@runs_once
def task1():
    print green('Start task1')
    with cd('/home/billy/tmp/'):
        run('ls -l')

@roles('server1')
def task2():
    print yellow('Start task2')
    with cd('/home/billy/tmp/'):
        upload=put('./test.txt', '/var/log/test1.txt', use_sudo=True)
        print upload.succeeded

@roles('server1')
def task3():
    print red('Start task3')
    with lcd('./tmp/'):
        filename = prompt("What is the file name?", default=11, validate=int)
        download=get('/home/billy/tmp/test1.txt','%s.txt' % filename)

@roles('server1')
def task4():
    print green('Start task4')
    with path('/home/billy/tmp'):
        sudo('echo $PATH')
    with settings(warn_only=True):
        run('echo $USER')
    with shell_env(JAVA_HOME='/opt/java'):
        run('echo $JAVA_HOME')
        local('echo $JAVA_HOME')
    with prefix('echo Hi'):
        run('echo $USER')
        local('echo $USER')

def multi():
    execute(task1)
    execute(task1)

def test():
    execute(task1)
    execute(task2)
    execute(task3)
    execute(task4)